package xyz.lychee.lagfixer.libs.adventure.text;

import java.util.stream.Stream;
import xyz.lychee.lagfixer.libs.annotations.Contract;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.ApiStatus.ScheduledForRemoval;
import xyz.lychee.lagfixer.libs.examination.ExaminableProperty;

public interface TextComponent extends BuildableComponent<TextComponent, Builder>, ScopedComponent<TextComponent> {
   /** @deprecated */
   @Deprecated
   @ScheduledForRemoval(
      inVersion = "5.0.0"
   )
   static @NotNull TextComponent ofChildren(final @NotNull ComponentLike... components) {
      return Component.textOfChildren(components);
   }

   @NotNull String content();

   @Contract(
      pure = true
   )
   @NotNull TextComponent content(final @NotNull String content);

   default @NotNull Stream<? extends ExaminableProperty> examinableProperties() {
      return Stream.concat(Stream.of(ExaminableProperty.of("content", this.content())), BuildableComponent.super.examinableProperties());
   }

   public interface Builder extends ComponentBuilder<TextComponent, Builder> {
      @NotNull String content();

      @Contract("_ -> this")
      @NotNull
      @NotNull Builder content(final @NotNull String content);
   }
}
